
# GelReportModels

This project contains several models used by Genomics England systems. This is a development guide, the models documentation can be found at [https://gelreportmodels.genomicsengland.co.uk](https://gelreportmodels.genomicsengland.co.uk).

Note: The link above is out of date due to DNS records not pointing to the Gitlab docs. These are found at [https://genomicsengland.gitlab.io/gelreportmodels/GelReportModels/](https://genomicsengland.gitlab.io/gelreportmodels/GelReportModels/)

## Validation in GRM 

Model validation check and raised if invalid through the use of `raise_if_invalid`. This functionality can be enabled by default on calls to:

  - `__init__`
  - `fromJsonDict` 
  - `fromJsonString`
  - `toJsonDict`
  - `toJsonString`

by enabling the DefaultValidation class in protocols.py

```
import protocols
protocols.DefaultValidation.enable()

```

## Making changes to GelReportModels

This details what you need to follow to make model changes GelReportModels.

### Making the model changes

In the folder `schemas/IDLs` you can find all the existing submodels and their versions.
This is what avro uses to automatically build the python models that are accessible when the application is built.

1. To make any changes, you need to modify the `current` version. For example, if I want to make a change to the 
CancerParticipant model I would make a change to the folder `schemas/IDLs/org.gel.models.participant.avro/current`. 
You then need to change `schemas/IDS/current_versions.json` to increment the version of the model you just changed. 

2. In the `protocols/resources/builds.json` file create a new protocol version referencing the new versions of 
the updated sub-models, not forgetting to add any new required dependency. This is still a manual step so that 
the major/minor has to manually be chosen. You do not need to include the `json_hash` fields, as these will be 
generated and updated automatically by the CI.

3. At this point you can run make `build__latest__model` locally and alongside other changes the current directory is
copied to the correct versioned directory, checking that this does not break existing versions as it does so. Note: 
changes generated by this step do not need to be committed, as these will be generated and updated automatically 
by the CI.

   
### Adding migrations

In the `protocols/migration` folder, create a new migration for forward and/or backward compatibility with the pre-existing models.
This should be done for every model that you changed.

### Adding unittests

Please create unittests in the `tests/` folder, following pytest standards. 

### Testing the changes

1) Build the docker image.
```shell
make build
```


2) Build the models using the image generated in the previous command.
```shell
make build__latest__model
```

This command is running `python build.py --latest` underneath, which calls avro-tools and generates the models in python code from the avdl files you've added.

The CI on Gitlab handles the python and java package versions based upon on the `builds.json`

3) Run the tests
```shell
make run__test
```

### What to commit

Please do not commit your auto generated python code or documentation. 
You should only need to commit the following in a routine model update:
* `current` directorys in `schemas/IDLs/`
* changes to migrations
* schemas/IDLs/current_versions.json
* protocols/resources/builds.json

## Current users of Gel Report Models in NGIS (October 2022)

Please see [#extending_gel_report_models](https://genomicsengland.slack.com/archives/C02BM02M65V) Slack channel for latest discussions

**Application**|              **Squad**              |                  **Product Owner**                  |  **Tech lead**   |                        **GRM version (Oct 2021)**                         |**GRM Models used**
:-----:|:-----------------------------------:|:---------------------------------------------------:|:----------------:|:-------------------------------------------------------------------------:|:-----:
TOTS|       Test Order and Tracking       |                 Tom Denlegh-Maxwell                 |   Chris Davies   |                                   None                                    | None
CDI|               CDM/SDM               |                 Victoria Ingamells                  |  Karik Isichei   | GMS Test: 7.8.1, Cohorts Test: 7.11, GMS Prod: 7.8.1, Cohorts Prod: 7.8.1 | GMS: Referral, GermlineSample, TumourSample .  Cohorts: Referral, GermlineSample, TumourSample.  BAMSS: Referral, GermlineSample, TumourSample, BirthClinicalQuestions
RAP Tool| Research Acquisition and Processing |                   Ray Rey-Raposo                    |  Shaun Harrison  |                           Test: 7.11, Prod: TBC                           | Cohorts: Referral, GermlineSample, TumourSample.  BAMSS: Referral, GermlineSample, TumourSample, BirthClinicalQuestions
OpenCGA|                KMDS                 |                    Carrie Mowat                     | Alasdair Colley  |                             Depends on study                              | TBC
Pipeline (Dispatch)|       bio-pipelines-delivery        | Tim Bouhour/Martha Imprialou/Eva Serra/Alex Younger |    Javi Lopez    |                         Test: 7.8.1, Prod: 7.8.1                          | InterpretationRequestRD, CancerInterpretationRequest, InterpretedGenome, ClinicalReport, AdditionalFindingsClinicalReport, Referral, GermlineSample, TumourSample, Variant, CallSet, Call + everything under org.gel.models.metrics.avro
Pipeline (RD Tiering)|       bio-pipelines-delivery        | Tim Bouhour/Martha Imprialou/Eva Serra/Alex Younger |    Javi Lopez    |                         Test: 7.8.1, Prod: 7.8.1                          | InterpretationRequestRD, CancerInterpretationRequest, InterpretedGenome, ClinicalReport, AdditionalFindingsClinicalReport, Referral, GermlineSample, TumourSample, Variant, CallSet, Call + everything under org.gel.models.metrics.avro
Pipeline (Cancer Tiering)|       bio-pipelines-delivery        | Tim Bouhour/Martha Imprialou/Eva Serra/Alex Younger |    Javi Lopez    |                         Test: 7.8.1, Prod: 7.8.1                          | InterpretationRequestRD, CancerInterpretationRequest, InterpretedGenome, ClinicalReport, AdditionalFindingsClinicalReport, Referral, GermlineSample, TumourSample, Variant, CallSet, Call + everything under org.gel.models.metrics.avro
Pipeline (Exomiser)|                 TBC                 |                         TBC                         |       TBC        |                           Test: TBC, Prod: TBC                            | TBC
PyCIPAPI|                 TBC                 |                         TBC                         |       TBC        |                           Test: TBC, Prod: TBC                            | TBC
PyArk|                 TBC                 |                         TBC                         |       TBC        |                           Test: TBC, Prod: TBC                            | TBC
CIP-API|       Interpretation Platform       |                     Tigeest Geremew                     | Michael Champion |                         Test: 8.5.0, Prod: 7.8.0                          |InterpretationRequestRD, CancerInterpretationRequest, InterpretedGenome, ClinicalReport, Referral, ReferralTest, RareDiseaseExitQuestionnaire, CancerExitQuestionnaire, Consent
CVA|       Interpretation Platform       |                     Liz Edwards                     | William Bellamy  |                         Test: 7.7.0, Prod: 7.7.0                          |
Congenica|                 TBC                 |                     Zahra Riaz                      |       TBC        |                           Test: TBC, Prod: TBC                            | TBC



These models are defined using Avro Interface Design Language (IDL) which is agnostic of any implementation language. The models are then used to generate source code employed to store the information. The source code is either Python or Java so far, but this can be easily extended.

From the Avro models you can generate:
* Java source code
* Python source code
* JSON schemas
* OpenCGA Catalog VariableSets

Maven is employed for Java dependency management. Particularly, OpenCB [https://github.com/opencb/biodata](https://github.com/opencb/biodata) models are imported through a maven dependency and then extracted into the local folder for schemas.
This is not required unless you upgrade OpenCB models version, as the OpenCB models are commited in the repository under `schemas/IDLs/org.opencb.biodata.models`.

To import the OpenCB dependency and extract the models in your local environment run:
```
% mvn clean initialize
```

## Versioning

Models are organised in **packages**:
* Internal
    - org.gel.models.report.avro
    - org.gel.models.participant.avro
    - org.gel.models.metrics.avro
    - org.gel.models.cva.avro
    - org.gel.models.system.avro
* External
    - org.ga4gh.models
    - org.opencb.biodata.models

A package is formed by a set of **schema files** having `.avdl` extension.

There are dependencies between packages that require that we **build** packages together.

Each of those packages support independent versioning. The `current` folder holds the current version of the model which is versioned by the `schemas/IDLS/current_versions.json`.  Also there are build versions that determine a set of specific packages that are built together.  This information is contained within `protocols/resources/builds.json` in an array of build descriptions. 


The following represents the build version `4.3.0-SNAPSHOT` having package org.ga4gh.models version 3.0.0, package org.gel.models.cva.avro version 0.4.0-SNAPSHOT and so on.
```
{
  "version": "4.3.0-SNAPSHOT",
  "packages": [
    {
      "package": "org.ga4gh.models",
      "python_package": "ga4gh",
      "version": "3.0.0",
      "dependencies": []
    },
    {
      "package": "org.gel.models.cva.avro",
      "python_package": "cva",
      "version": "0.4.0-SNAPSHOT",
      "dependencies": [
        "org.gel.models.report.avro",
        "org.gel.models.participant.avro",
        "org.gel.models.system.avro",
        "org.opencb.biodata.models"
      ]
    },
    {
      "package": "org.gel.models.metrics.avro",
      "python_package": "metrics",
      "version": "1.1.0-SNAPSHOT",
      "dependencies": []
    },
    {
      "package": "org.gel.models.participant.avro",
      "python_package": "participant",
      "version": "1.0.4-SNAPSHOT",
      "dependencies": []
    },
    {
      "package": "org.gel.models.report.avro",
      "python_package": "reports",
      "version": "4.2.0-SNAPSHOT",
      "dependencies": [
        "org.gel.models.participant.avro"
      ]
    },
    {
      "package": "org.gel.models.system.avro",
      "python_package": "system",
      "version": "0.1.0-SNAPSHOT",
      "dependencies": []
    },
    {
      "package": "org.opencb.biodata.models",
      "python_package": "opencb",
      "version": "1.3.0-SNAPSHOT",
      "dependencies": []
    }
  ]
}
```

Every package in a build is built in a sandbox folder under `schemas/IDLs/build` together with those packages in the list of dependencies for each package. This introduces two strong constraints in the models:
* The same package cannot contain two objects named equally in different schema files
* Schema files in different packages cannot be named equally


## Getting started

``

# Build the models
To build all builds described in `protocols/resources/builds.json` run:
```
% python build.py
```

This will create the following:
* Python source code representing the Avro records in the folder `./protocols/`
* Java source code representing the Avro records in the folder `./target/generated-sources/avro`
* The models documentation under `./docs/`
* Any required OpenCGA Catalog variable set definitions under `./protocols/catalog_variable_sets`


### Building legacy versions of the models

See `protocols/resources/builds.json` for the information on all legacy versions and the specific package versions and dependencies in each of those.

To build a specific version run:
```
% python build.py --version 3.0.0
```

### Building OpenCGA Catalog Variable Sets

Avro record definitions can be converted into OpenCGA Catalog VariableSet definitions.
These are selectively generated according to configuration in `builds.json` and are
created during the Python code generation build phase.

For example 

```
{
  "builds": [
    {
      "version": "7.10",
      "packages": [
        {
          "package": "org.gel.models.metrics.avro",
          "python_package": "metrics",
          "version": "1.2.2",
          "dependencies": [
            "org.gel.models.participant.avro"
          ],
          "catalog_variable_sets": [
            "FamilySelection",
            "ReportedVsGeneticChecks",
            "RareDiseaseInterpretationStatus"
          ]
        },
```

The `catalog_variable_sets` is an optional entry for each package, and contains the names of the record
definitions that should be converted to VariableSet definitions in json.

The output is generated here:

`./protocols/catalog_variable_set/v<build-version>/<package-name>_<package-version>/<record-name>.catalog_vs.json`

eg

`./protocols/catalog_variable_set/v7.10/org.gel.models.metrics.avro_1.2.2/FamilySelection.catalog_vs.json`



### Other build options

Use `--docs` to generate documentation which affects build time greatly.

Use `--java` to generate Java source code.

Use `--skip-python` to skip generating Python source code.

Use `--latest` to build latest models


### Building Resources From a Container
From your starting directory, eg. ~/gel/:

Clone this repo
```
git@gitlab.com:genomicsengland/gelreportmodels/GelReportModels.git
```

Then run the following (you may need `sudo` depending on your system configuration):

```
make build__models
```

### Running tests

```
make run__test
```


### Java Packaging

To pack the Java source code representing these models in a jar file use:
```
% mvn package
```

To install it in your system so it is accessible as a maven dependency to other Java applications run:
```
% mvn install
```



## Mock data

Generate a mocked object with custom fields as follows:
```
from protocols.util.dependency_manager import VERSION_500
from protocols.util.factories.avro_factory import GenericFactoryAvro

interpretation_request_factory = GenericFactoryAvro.get_factory_avro(
    protocols.protocols_5_0_0.reports.InterpretationRequestRD,
    
    version = VERSION_500
)
instance = interpretation_request_factory(analysisReturnUri = "myURI")
self.assertTrue(instance.validate(instance.toJsonDict()))
self.assertTrue(instance.analysisReturnUri == "myURI")
```

## Serialisation to/from JSON

Given that you hold your data in JSON format in a string in memory deserialise as follows:

```python
    
    from protocols.protocol_4_0_0.reports import CancerInterpretationRequest as CancerInterpretationRequest_4_0_0
    instance = CancerInterpretationRequest_4_0_0.fromJsonString(json_string)
    # now you can access the data in the instance
    print("This interpretation request has {} variants".format(instance.tieredVariants))
```

If your data is hold in a Python dictionary in memory deserialise as follows:

```python
    instance = CancerInterpretationRequest_4_0_0.fromJsonDict(json_dict)
```


The object can be serialised into JSON as follows:

```python
    instance.toJsonDict()
    instance.toJsonString()
```
